/** Tests selection sort of an array of 
    doubles. HJG 27/04/01 */
public class GapSortTest
{
    /** @param data an array of doubles
	@return sorted data array */
    public static void gapSort(double[] data)
    {
	final double shrinkFactor = 1.3;

	boolean interchanged = true;
	int gap = data.length;
	while (interchanged || (gap!=1))
	{    
	    interchanged = false;
	    gap = (int) (gap/shrinkFactor);
	    if (gap == 0) gap = 1;
            int maxIndex = data.length-gap;
	    
	    for (int i=0; i<maxIndex; i++)
	    {
		int j = i + gap;
		if (data[i]>data[j])
		{
		    double temp = data[j];
		    data[j] = data[i];
		    data[i] = temp;
		    interchanged=true;
		}
	    }
	}
    }

    public static void main(String[] args)
    {
	//	double[] data = {5., 0., -2.3, -0.3, 7.};
	//	double[] data = {5., 0., -2.3, -0.3, -7.};
    //   	double[] data = {5.};
	int ndata = 50;
	double[] data = new double[ndata];
	for (int i = 0; i< data.length; i++)
	data[i]=ndata-i;

	System.out.println("Data array: ");
	for (int i = 0; i<data.length;i++) 
	    System.out.print(data[i] + " ");
	    System.out.println("");
	gapSort(data);
	System.out.println("Sorted data array");
	for (int i = 0; i<data.length;i++) 
	    System.out.print(data[i] + " ");
	    System.out.println("");
    }
}
